︠e4616ab5-85c0-4ece-870d-acbf39919dc0i︠
%html
<p>This worksheet was produced by Ken Ribet in connection with the spring, 2010 crytography course at UC Berkeley. &nbsp;The course uses using the textbook ``An introduction to mathematical cryptography'' by Hopffstein, Pipher and Silverman. &nbsp;In section 4.5 of the book, the authors talk about the Pollard $\rho$ method for finding discrete logs. &nbsp;In this worksheet, Ken implements the method to find a discrete log for the prime $144169$. &nbsp;Amazingly, the method worked!</p>

︡3617d621-acb8-4857-9f1d-7f2202f37897︡{"html": "<p>This worksheet was produced by Ken Ribet in connection with the spring, 2010 crytography course at UC Berkeley. &nbsp;The course uses using the textbook ``An introduction to mathematical cryptography'' by Hopffstein, Pipher and Silverman. &nbsp;In section 4.5 of the book, the authors talk about the Pollard $\\rho$ method for finding discrete logs. &nbsp;In this worksheet, Ken implements the method to find a discrete log for the prime $144169$. &nbsp;Amazingly, the method worked!</p>"}︡
︠5991c14e-21be-41a8-b03f-abec5eb03404︠
def experiment(n):
   if n==0:  return
   elif v[n-1][0] < floor(p/3): v.append([Mod(g*v[n-1][0],p),v[n-1][1],Mod(v[n-1][2]+1,p-1),n]); return
   elif v[n-1][0] < floor(2*p/3): v.append([Mod(v[n-1][0]^2,p), Mod(2*v[n-1][1],p-1), Mod(2*v[n-1][2],p-1),n]); return
   else: v.append([Mod(h*v[n-1][0],p),Mod(v[n-1][1]+1,p-1), v[n-1][2],n ]); return
︡f78e2c61-da3e-435b-8055-9b76365b4349︡︡
︠441b3d76-6406-445a-bcbb-a0dc9a6b809di︠
%html
<p>The code above is supposed to make the recursive Pollard $\rho$ sequence $x_i$ as in the book. &nbsp;Since I'm no programmer, you can surely do better. &nbsp;For each $i$, starting with $i=0$, I create a 4-tuple $(x_i,a_i,b_i,i)$, where $x_i = h^{a_i}g^{b_i}$.</p>

<p>This initializes the matrix of 4-tuples---I supply the first line:</p>

︡be4fee5c-4394-4148-9f63-05e277f66331︡{"html": "<p>The code above is supposed to make the recursive Pollard $\\rho$ sequence $x_i$ as in the book. &nbsp;Since I'm no programmer, you can surely do better. &nbsp;For each $i$, starting with $i=0$, I create a 4-tuple $(x_i,a_i,b_i,i)$, where $x_i = h^{a_i}g^{b_i}$.</p>\n\n<p>This initializes the matrix of 4-tuples---I supply the first line:</p>"}︡
︠73244390-954a-4a1b-986a-41551250644d︠
v=[[1,0,0,0]]
︡36816015-5acc-4d9b-8575-f87c9d372faf︡︡
︠d0b3b311-38fc-4eec-ba8f-6206b2847c26︠
p= 144169
︡aee6ac18-759a-4193-845e-5c9778585db8︡︡
︠1823dd5d-7c96-4ebb-b6ec-6b6da56f92ac︠
primitive_root(p)
︡6c91f040-46c4-4432-9fa4-b9b0250c62c5︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}23</span>"}︡
︠41cdc48a-cfff-4687-83a0-d784f48de269i︠
%html
<p>I take $g$ to be the smallest primitive root mod $p=144169$, which you know to be one of my favorite primes. &nbsp;For $h$, I take 2010; why not?!</p>

︡00290979-bb1c-46e6-8e3e-f32f998c60ea︡{"html": "<p>I take $g$ to be the smallest primitive root mod $p=144169$, which you know to be one of my favorite primes. &nbsp;For $h$, I take 2010; why not?!</p>"}︡
︠5f673e6b-abfa-47ab-ac16-af68cba436a3︠
g = Mod(23,p)
︡93bb63ec-baa3-4e88-a461-619248748c7d︡︡
︠96da144e-90cf-4114-8447-57c5a8f1e4fe︠
h = Mod(2010,p)
︡1d69d07a-5f47-4c0f-9ff2-e57165d0e2ff︡︡
︠03fba808-be31-437f-8b97-8e6cce334f63i︠
%html
<p>By running the ``experiment'' program 50 times, I build up the matrix of 4-tuples.</p>

︡6247a495-2a3a-471a-9a27-ff5bc29bcf97︡{"html": "<p>By running the ``experiment'' program 50 times, I build up the matrix of 4-tuples.</p>"}︡
︠ca7d7540-d27a-453e-bc58-ff7ea3fba021︠
for i in range(50):
    experiment(i)
︡a8a17ec0-4521-46a0-a7ba-1075f462f909︡︡
︠59a6842a-2805-41ed-9747-e1e0cae2ba7c︠
m=matrix(ZZ,v)
︡46e4b54a-6cb0-474e-a6d0-c7e22cd49d97︡︡
︠a43905e2-b48d-43ba-b47b-e6182d154419i︠
%html
<p>The matrix command turns the list $v$ into a matrix with integral coefficients.</p>

︡c13ca1d5-e233-4ce6-9730-a68d5832dc8d︡{"html": "<p>The matrix command turns the list $v$ into a matrix with integral coefficients.</p>"}︡
︠4a5dcf65-df80-47f5-b848-252e5229d1c6︠
show(m)
︡57aea21c-af2c-4eff-8fc9-77b3b5df2431︡{"html": "<div class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}\\left(\\begin{array}{rrrr}\n1 & 0 & 0 & 0 \\\\\n23 & 0 & 1 & 1 \\\\\n529 & 0 & 2 & 2 \\\\\n12167 & 0 & 3 & 3 \\\\\n135672 & 0 & 4 & 4 \\\\\n77141 & 1 & 4 & 5 \\\\\n14237 & 2 & 8 & 6 \\\\\n39113 & 2 & 9 & 7 \\\\\n34585 & 2 & 10 & 8 \\\\\n74610 & 2 & 11 & 9 \\\\\n142841 & 4 & 22 & 10 \\\\\n69931 & 5 & 22 & 11 \\\\\n132281 & 10 & 44 & 12 \\\\\n37174 & 11 & 44 & 13 \\\\\n134157 & 11 & 45 & 14 \\\\\n59540 & 12 & 45 & 15 \\\\\n40059 & 24 & 90 & 16 \\\\\n56343 & 24 & 91 & 17 \\\\\n76438 & 48 & 182 & 18 \\\\\n30781 & 96 & 364 & 19 \\\\\n131287 & 96 & 365 & 20 \\\\\n57600 & 97 & 365 & 21 \\\\\n142972 & 194 & 730 & 22 \\\\\n44903 & 195 & 730 & 23 \\\\\n23586 & 195 & 731 & 24 \\\\\n109971 & 195 & 732 & 25 \\\\\n30633 & 196 & 732 & 26 \\\\\n127883 & 196 & 733 & 27 \\\\\n135672 & 197 & 733 & 28 \\\\\n77141 & 198 & 733 & 29 \\\\\n14237 & 396 & 1466 & 30 \\\\\n39113 & 396 & 1467 & 31 \\\\\n34585 & 396 & 1468 & 32 \\\\\n74610 & 396 & 1469 & 33 \\\\\n142841 & 792 & 2938 & 34 \\\\\n69931 & 793 & 2938 & 35 \\\\\n132281 & 1586 & 5876 & 36 \\\\\n37174 & 1587 & 5876 & 37 \\\\\n134157 & 1587 & 5877 & 38 \\\\\n59540 & 1588 & 5877 & 39 \\\\\n40059 & 3176 & 11754 & 40 \\\\\n56343 & 3176 & 11755 & 41 \\\\\n76438 & 6352 & 23510 & 42 \\\\\n30781 & 12704 & 47020 & 43 \\\\\n131287 & 12704 & 47021 & 44 \\\\\n57600 & 12705 & 47021 & 45 \\\\\n142972 & 25410 & 94042 & 46 \\\\\n44903 & 25411 & 94042 & 47 \\\\\n23586 & 25411 & 94043 & 48 \\\\\n109971 & 25411 & 94044 & 49\n\\end{array}\\right)</div>"}︡
︠9340b47e-883e-4025-955b-438cbcd3a9bfi︠
%html
<p>The number $135672$ occurs for $i=4$ and $i=28$. &nbsp;That's our collision! &nbsp;We get the equation $g^4=h^{197}g^{733}$, which we can simplify to $g^{729}=h^{143971}$. &nbsp;(Note that the exponents run mod $p-1$.) &nbsp;It so happens that $\gcd(143971,p-1)=1$, so that we can solve for the discrete log directly by inverting 143971 mod $p-1$. &nbsp;In other situations, the gcd might be some number $t&gt;1$. &nbsp;In that case, we find the discrete log only mod $(p-1)/t$, which leaves $t$ different possibilities for the discrete log. &nbsp;We then find the true discrete log by checking in turn each of the $t$ possibilities.</p>
<p>When I started computing discrete logs by this method a day or two ago, the first example I ran had $p=1009$, $g=11$, $h=100$. &nbsp;(Don't ask why I took $h$ to be a perfect square; that was a bit silly, I admit.) &nbsp;My collision produced the equation $h^{18}=g^{432}$. &nbsp;Since the gcd in this case is $t=18$, I had the discrete log only mod $(p-1)/18 = 56$: it was 24 mod 56. &nbsp;The discrete log in this case turned out to be $24+2\cdot 56=136$.</p>

︡e564665b-81da-45fc-81bf-d0c430f57e1e︡{"html": "<p>The number $135672$ occurs for $i=4$ and $i=28$. &nbsp;That's our collision! &nbsp;We get the equation $g^4=h^{197}g^{733}$, which we can simplify to $g^{729}=h^{143971}$. &nbsp;(Note that the exponents run mod $p-1$.) &nbsp;It so happens that $\\gcd(143971,p-1)=1$, so that we can solve for the discrete log directly by inverting 143971 mod $p-1$. &nbsp;In other situations, the gcd might be some number $t&gt;1$. &nbsp;In that case, we find the discrete log only mod $(p-1)/t$, which leaves $t$ different possibilities for the discrete log. &nbsp;We then find the true discrete log by checking in turn each of the $t$ possibilities.</p>\n<p>When I started computing discrete logs by this method a day or two ago, the first example I ran had $p=1009$, $g=11$, $h=100$. &nbsp;(Don't ask why I took $h$ to be a perfect square; that was a bit silly, I admit.) &nbsp;My collision produced the equation $h^{18}=g^{432}$. &nbsp;Since the gcd in this case is $t=18$, I had the discrete log only mod $(p-1)/18 = 56$: it was 24 mod 56. &nbsp;The discrete log in this case turned out to be $24+2\\cdot 56=136$.</p>"}︡
︠7c98f2b9-b6be-41ed-b071-68eb7e012c3b︠
Mod(729/143971,p-1)
︡597739b0-bf8e-4d6f-8642-6a6d01dc21ce︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}21219</span>"}︡
︠9d098fdc-1237-4fba-b740-40aa2d56d284i︠
%html
<p>This $21219$ is the discrete log that has been found by the Pollard method. &nbsp;In the next cell, I call sage's discrete log command to check the work.</p>

︡658650e9-f43b-49af-b577-d747ba8d34bf︡{"html": "<p>This $21219$ is the discrete log that has been found by the Pollard method. &nbsp;In the next cell, I call sage's discrete log command to check the work.</p>"}︡
︠b9ed9af7-c45b-45ee-a4d0-e0beafeda052︠
log(h,g)
︡349c1ded-f801-4d14-b7e9-a923033434b7︡{"html": "<span class=\"math\">\\newcommand{\\Bold}[1]{\\mathbf{#1}}21219</span>"}︡
